import bpy

bl_info = {
    "name": "Panda3d exporter(.egg)",
    "author": "ninth",
    "version": (0, 1, 0),
    "blender": (2, 5, 8),
    "api": 36339,
    "location": "File > Export > egg (.egg)",
    "description": "Export to Panda3d (.egg)",
    "warning": "work in progress",
    "wiki_url": "http://www.panda3d.org/forums/viewtopic.php?t=11441/",
    "tracker_url": "http://www.panda3d.org/forums/viewtopic.php?t=11441",
    "category": "Import-Export"}




##################################################################
def write_some_data(context, filepath, use_setting, use_setting2,use_setting3,StartFrame, EndFrame, FrameRate,AnimationName,use_setting4,tpath):
         # -------------- Change this to setup parameters -----------------------
        #: file name to write
        FILE_PATH = filepath

        sfX = int(StartFrame)
        efX = int(EndFrame)
        frX = int(FrameRate)
        #: { 'animation_name' : (start_frame, end_frame, frame_rate) }
        ANIMATIONS = {AnimationName:(sfX,efX,frX), 
                      }

        #: 'True' to interprete an image in the uv layer as the texture
        if use_setting4 == True:
            EXPORT_UV_IMAGE_AS_TEXTURE = True 
        else:
             EXPORT_UV_IMAGE_AS_TEXTURE = False 
        

        #: 'True' to copy texture images together with main.egg
        if use_setting3 == True:
            COPY_TEX_FILES = True
        else:
            COPY_TEX_FILES = False
        
        #: Path for the copied textures. Relative to the main EGG file dir.
        #: For example if main file path is '/home/username/test/test.egg',
        #: texture path is './tex', then the actual texture path is 
        #: '/home/username/test/tex'
        TEX_PATH = tpath

        #: 'True' to write an animation data into the separate files
        if use_setting == True:
            SEPARATE_ANIM_FILE = True
        else:
            SEPARATE_ANIM_FILE = False
        

        #: 'True' to write only animation data
        if use_setting2 == True:
            ANIM_ONLY = True
        else:
            ANIM_ONLY = False
        
        

        #: number of sign after point
        FLOATING_POINT_ACCURACY = 3
        # ----------------------------------------------------------------------

        import bpy, os, sys


       
                
        import yabee_libs.egg_writer
        print('RELOADING MODULES')
        import imp
        imp.reload(yabee_libs)
        imp.reload(yabee_libs.egg_writer)
        imp.reload(yabee_libs.tbn_generator)

        yabee_libs.egg_writer.write_out(FILE_PATH, 
                                        ANIMATIONS,
                                        EXPORT_UV_IMAGE_AS_TEXTURE, 
                                        SEPARATE_ANIM_FILE, 
                                        ANIM_ONLY,
                                        COPY_TEX_FILES, 
                                        TEX_PATH, 
                                        FLOATING_POINT_ACCURACY)
        return {'FINISHED'}

##################################################################
   



from bpy_extras.io_utils import ExportHelper
from bpy.props import StringProperty, BoolProperty, EnumProperty, FloatProperty


class ExportSomeData(bpy.types.Operator, ExportHelper):
    '''Export to the Panda3d game engine'''
    bl_idname = "export.some_data"  
    bl_label = "Panda3d Export"

    
    filename_ext = ".egg"

    filter_glob = StringProperty(default="*.egg", options={'HIDDEN'})

    use_setting4 = BoolProperty(name="Export UV image as texture", description="Choose how UV images are used", default=False)
    use_setting3 = BoolProperty(name="Collect Maps", description="gather texture files", default=True)
    use_setting = BoolProperty(name="Place animation in seperate egg", description="Create egg for animation", default=True)
    use_setting2 = BoolProperty(name="Animation only", description="Do not export model data", default=False)
    
    StartFrame = FloatProperty(name="Start Frame", description="Start Frame", default = 1,min=1.0, soft_min=1.0, max=100.0, soft_max=100.0)
    EndFrame = FloatProperty(name="End Frame", description="End Frame", default = 10,min=1.0, soft_min=1.0, max=100.0, soft_max=100.0)
    FrameRate = FloatProperty(name="FPS", description="Frames per second", default = 35,min=1.0, soft_min=1.0, max=100.0, soft_max=100.0)
    AnimationName = StringProperty(name="Animation Name", description="Animation Name", default = "Animation1")
    tpath = StringProperty(name="Map Export Folder", description="Directory where textures will be exported to", default = "./maps")
   

    @classmethod
    def poll(cls, context):
        return context.active_object != None

    def execute(self, context):
        return write_some_data(context, self.filepath, self.use_setting, self.use_setting2,self.use_setting3, self.StartFrame, self.EndFrame, self.FrameRate, self.AnimationName, self.use_setting4, self.tpath)



def menu_func_export(self, context):
    self.layout.operator(ExportSomeData.bl_idname, text="Panda3d(.egg)")


def register():
    bpy.utils.register_class(ExportSomeData)
    bpy.types.INFO_MT_file_export.append(menu_func_export)


def unregister():
    bpy.utils.unregister_class(ExportSomeData)
    bpy.types.INFO_MT_file_export.remove(menu_func_export)


if __name__ == "__main__":
    register()

    
